JazzWriterParser Class Reference documentation

JazzWriterParser Class Referencefinal

the main class to read a Jazz(Lotus) word file More...

`#include <JazzWriterParser.hxx>`

Inheritance diagram for JazzWriterParser:

## Public Member Functions
| JazzWriterParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~JazzWriterParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | readParagraph (MWAWEntry const &entry)
| tries to read the WPPD zones
bool | readPLC (MWAWEntry const &entry)
| tries to read the WSCR zones
bool | readZone (MWAWEntry const &entry)
| tries to read the WDoc zones
bool | sendZone (unsigned zId)
| try to send a zone
bool | sendParagraph (unsigned pId)
| try to send a paragraph
bool | sendPLC (unsigned pId)
| try to send a plc
bool | getPicture (unsigned pId, MWAWEmbeddedObject &obj)
| try to retrieve a picture
bool | createZones ()
| finds the different objects zones
bool | checkZones ()
| checks that the main zone exists (and its potential header/footer) and that there are valid.
bool | checkParagraphs (unsigned id, long &num, std::set< unsigned > &seens) const
| check that a paragraph, its style and its followings exist (and do not create loops) and update the number of characters
bool | countCharactersInPLC (unsigned plcId, long &n)
| retrieve the number of characters corresponding to a PLC
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
bool | readString (MWAWInputStreamPtr input, librevenge::RVNGString &string, long endPos)
| try to read a C-string
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< JazzWriterParserInternal::State > | m_state
| the state

## Friends
class | JazzWriterParserInternal::SubDocument

## Detailed Description

the main class to read a Jazz(Lotus) word file

## Constructor & Destructor Documentation

## ◆ JazzWriterParser()

JazzWriterParser::JazzWriterParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

Referenced by checkParagraphs().

## ◆ ~JazzWriterParser()

JazzWriterParser::~JazzWriterParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool JazzWriterParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by JazzWriterParserInternal::SubDocument, and parse().

## ◆ checkParagraphs()

bool JazzWriterParser::checkParagraphs | ( | unsigned | id,
|  | long & | num,
|  | std::set< unsigned > & | seens ) const
| protected

check that a paragraph, its style and its followings exist (and do not create loops) and update the number of characters

Referenced by checkParagraphs(), checkZones(), and readPLC().

## ◆ checkZones()

bool JazzWriterParser::checkZones | ( |  | ) |
| protected

checks that the main zone exists (and its potential header/footer) and that there are valid.

Enumerates also the number of characters in each zones and check that the data fork contains enough characters.

Referenced by createZones(), and readPLC().

## ◆ countCharactersInPLC()

bool JazzWriterParser::countCharactersInPLC | ( | unsigned | plcId,
|  | long & | n )
| protected

retrieve the number of characters corresponding to a PLC

Referenced by checkParagraphs(), and readPLC().

## ◆ createDocument()

void JazzWriterParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by JazzWriterParserInternal::SubDocument, and parse().

## ◆ createZones()

bool JazzWriterParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and readPLC().

## ◆ getPicture()

bool JazzWriterParser::getPicture | ( | unsigned | pId,
|  | MWAWEmbeddedObject & | obj )
| protected

try to retrieve a picture

Referenced by readPLC(), and sendPLC().

## ◆ parse()

void JazzWriterParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by JazzWriterParserInternal::SubDocument.

## ◆ readParagraph()

bool JazzWriterParser::readParagraph | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the WPPD zones

Referenced by createZones(), and JazzWriterParserInternal::SubDocument.

## ◆ readPLC()

bool JazzWriterParser::readPLC | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the WSCR zones

Referenced by readPLC().

## ◆ readString()

bool JazzWriterParser::readString | ( | MWAWInputStreamPtr | input,
|  | librevenge::RVNGString & | string,
|  | long | endPos )
| protected

try to read a C-string

Referenced by createZones(), and readPLC().

## ◆ readZone()

bool JazzWriterParser::readZone | ( | MWAWEntry const & | entry | ) |
| protected

tries to read the WDoc zones

Referenced by createZones(), and readPLC().

## ◆ rsrcAscii()

libmwaw::DebugFile & JazzWriterParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), getPicture(), readParagraph(), readPLC(), readZone(), and sendPLC().

## ◆ rsrcInput()

MWAWInputStreamPtr JazzWriterParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by countCharactersInPLC(), createDocument(), createZones(), getPicture(), readParagraph(), readPLC(), readZone(), and sendPLC().

## ◆ sendParagraph()

bool JazzWriterParser::sendParagraph | ( | unsigned | pId | ) |
| protected

try to send a paragraph

Referenced by readPLC(), sendParagraph(), and sendZone().

## ◆ sendPLC()

bool JazzWriterParser::sendPLC | ( | unsigned | pId | ) |
| protected

try to send a plc

Referenced by readPLC(), and sendParagraph().

## ◆ sendZone()

bool JazzWriterParser::sendZone | ( | unsigned | zId | ) |
| protected

try to send a zone

Referenced by parse(), and readPLC().

## Friends And Related Symbol Documentation

## ◆ JazzWriterParserInternal::SubDocument

friend class JazzWriterParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<JazzWriterParserInternal::State> JazzWriterParser::m_state
| protected

the state

Referenced by checkHeader(), checkParagraphs(), checkZones(), createDocument(), JazzWriterParser(), readParagraph(), readZone(), sendParagraph(), and sendZone().

The documentation for this class was generated from the following files:

- JazzWriterParser.hxx
- JazzWriterParser.cxx